"use strict";

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _path = require("path");

var _path2 = _interopRequireDefault(_path);

var _internals = require("./internals");

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var fs = require("fs");
var publicPath = "./public";

exports.onPostBuild = function () {
  var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(_ref, pluginOptions) {
    var graphql = _ref.graphql;

    var options, siteQuery, site, _loop, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, feed;

    return _regenerator2.default.wrap(function _callee$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            delete pluginOptions.plugins;
            options = (0, _extends3.default)({}, pluginOptions);
            _context2.next = 4;
            return (0, _internals.runQuery)(graphql, options.siteQuery);

          case 4:
            siteQuery = _context2.sent;
            site = siteQuery.site;
            _loop = /*#__PURE__*/_regenerator2.default.mark(function _loop(feed) {
              var feedQuery, query, feedItems, output;
              return _regenerator2.default.wrap(function _loop$(_context) {
                while (1) {
                  switch (_context.prev = _context.next) {
                    case 0:
                      _context.next = 2;
                      return (0, _internals.runQuery)(graphql, feed.query);

                    case 2:
                      feedQuery = _context.sent;
                      query = (0, _extends3.default)({}, siteQuery, feedQuery);
                      feedItems = feed.normalize({ query: query });
                      // console.log(feedItems);

                      output = (0, _utils.buildFeed)((0, _extends3.default)({
                        site: site,
                        items: feedItems,
                        name: feed.name,
                        addToHeader: feed.addToHeader ? feed.addToHeader : true,
                        path: feed.path ? feed.path : publicPath
                      }, feed.options));


                      if (!fs.existsSync(feed.path)) {
                        fs.mkdirSync(feed.path, { recursive: true }, function (err) {});
                      }
                      // console.log(options);

                      if (!feed.json) {
                        _context.next = 10;
                        break;
                      }

                      _context.next = 10;
                      return (0, _internals.writeFile)(_path2.default.join(feed.path, feed.name + ".json"), output.json1(), "utf8").catch(function (r) {
                        console.log("Failed to write " + feed.path + "/" + feed.name + ".json file: ", r);
                      });

                    case 10:
                      if (!feed.xml) {
                        _context.next = 13;
                        break;
                      }

                      _context.next = 13;
                      return (0, _internals.writeFile)(_path2.default.join(feed.path, feed.name + ".xml"), output.rss2(), "utf8").catch(function (r) {
                        console.log("Failed to write " + feed.path + "/" + feed.name + ".xml file: ", r);
                      });

                    case 13:
                      if (!feed.rss) {
                        _context.next = 16;
                        break;
                      }

                      _context.next = 16;
                      return (0, _internals.writeFile)(_path2.default.join(feed.path, "" + feed.rssName), output.rss2(), "utf8").catch(function (r) {
                        console.log("Failed to write " + feed.path + "/" + feed.rssName + " file: ", r);
                      });

                    case 16:
                    case "end":
                      return _context.stop();
                  }
                }
              }, _loop, undefined);
            });
            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            _context2.prev = 10;
            _iterator = options.feeds[Symbol.iterator]();

          case 12:
            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
              _context2.next = 18;
              break;
            }

            feed = _step.value;
            return _context2.delegateYield(_loop(feed), "t0", 15);

          case 15:
            _iteratorNormalCompletion = true;
            _context2.next = 12;
            break;

          case 18:
            _context2.next = 24;
            break;

          case 20:
            _context2.prev = 20;
            _context2.t1 = _context2["catch"](10);
            _didIteratorError = true;
            _iteratorError = _context2.t1;

          case 24:
            _context2.prev = 24;
            _context2.prev = 25;

            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }

          case 27:
            _context2.prev = 27;

            if (!_didIteratorError) {
              _context2.next = 30;
              break;
            }

            throw _iteratorError;

          case 30:
            return _context2.finish(27);

          case 31:
            return _context2.finish(24);

          case 32:
            return _context2.abrupt("return", Promise.resolve());

          case 33:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee, undefined, [[10, 20, 24, 32], [25,, 27, 31]]);
  }));

  return function (_x, _x2) {
    return _ref2.apply(this, arguments);
  };
}();