'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _urlJoin = require('url-join');

var _urlJoin2 = _interopRequireDefault(_urlJoin);

var _gatsby = require('gatsby');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.onRenderBody = function (_ref, pluginOptions) {
  var setHeadComponents = _ref.setHeadComponents;
  var rss = pluginOptions.rss,
      json = pluginOptions.json,
      feeds = pluginOptions.feeds,
      baseUrl = pluginOptions.baseUrl,
      putnoIndex = pluginOptions.putnoIndex;


  var output = [];

  // console.log(putnoIndex);


  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = feeds[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var feed = _step.value;


      if (feed.addToHeader === true) {

        var siteUrl = feed.baseUrl || '/';
        if (rss) {
          var rssurl = (0, _urlJoin2.default)(siteUrl, feed.name).replace(/\/+$/, '') + '.xml';
          output.push(_react2.default.createElement('link', {
            rel: 'alternate',
            key: 'gatsby-feed-rss',
            type: 'application/rss+xml',
            href: rssurl
          }));
        }

        if (json) {
          var jsonurl = (0, _urlJoin2.default)(siteUrl, feed.name).replace(/\/+$/, '') + '.json';
          output.push(_react2.default.createElement('link', {
            rel: 'alternate',
            key: 'gatsby-feed-json',
            type: 'application/json',
            href: jsonurl
          }));
        }
        if (putnoIndex == true) {
          output.push(_react2.default.createElement('meta', { name: 'robots', content: 'noindex' }));
        }
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  setHeadComponents(output);
};