"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.buildFeed = undefined;

var _typeof2 = require("babel-runtime/helpers/typeof");

var _typeof3 = _interopRequireDefault(_typeof2);

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _feed = require("feed");

var _urlJoin = require("url-join");

var _urlJoin2 = _interopRequireDefault(_urlJoin);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var buildFeed = function buildFeed(_ref) {
  var site = _ref.site,
      items = _ref.items,
      name = _ref.name,
      addToHeader = _ref.addToHeader,
      path = _ref.path,
      _ref$options = _ref.options,
      options = _ref$options === undefined ? {} : _ref$options;
  var _site$siteMetadata = site.siteMetadata,
      siteUrl = _site$siteMetadata.siteUrl,
      description = _site$siteMetadata.description,
      title = _site$siteMetadata.title,
      author = _site$siteMetadata.author;

  var feed = new _feed.Feed((0, _extends3.default)({
    title: title,
    description: description,
    copyright: "All rights reserved " + new Date().getFullYear() + ", " + author,
    id: siteUrl,
    link: siteUrl,
    type: "application/rss+xml",
    // image: urlJoin(siteUrl, 'image.png'),
    favicon: (0, _urlJoin2.default)(siteUrl, "favicon.ico"),
    generator: "GatsbyJS",
    feedLinks: {
      json: (0, _urlJoin2.default)(siteUrl, name).replace(/\/+$/, "") + ".json",
      rss: (0, _urlJoin2.default)(siteUrl, name).replace(/\/+$/, "") + ".xml"
    },
    author: {
      name: author
    }
  }, options));

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = items[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var item = _step.value;
      var _title = item.title,
          url = item.url,
          date = item.date,
          image = item.image,
          html = item.html,
          _item$excerpt = item.excerpt,
          excerpt = _item$excerpt === undefined ? "" : _item$excerpt,
          rest = (0, _objectWithoutProperties3.default)(item, ["title", "url", "date", "image", "html", "excerpt"]);

      var d = (typeof date === "undefined" ? "undefined" : (0, _typeof3.default)(date)) === "object" ? date : new Date(date);
      if (_title && d && d != "Invalid Date") {
        feed.addItem((0, _extends3.default)({
          title: _title,
          link: url,
          description: excerpt,
          content: html,
          image: image,
          id: url,
          date: d != "Invalid Date" ? d : new Date()
        }, rest));
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return feed;
};

exports.buildFeed = buildFeed;